#include<stdio.h>
#include<stdlib.h>
#include<time.h>

#define COLUMNS 3
#define ROWS 2


int matrix_1[2][3] = {{1,2,3},
    {4,5,6}
};

int matrix_4[ROWS][COLUMNS];
int matrix_5[ROWS][COLUMNS];

int matrix_2[3][2] = {{1,2},
    {3,4},
    {5,6}
};

int matrix_3[3][2];

int result_matrix[2][2];


int square_matrix[3][3] = {{1,2,3},{4,5,6}, {7,8,9}};

void print_rectangular_matrix(int matrix[ROWS][COLUMNS])
{
    int i,j;
    for(i=0; i<ROWS; i++) {
        for(j=0; j<COLUMNS; j++)
            printf("%4d",matrix[i][j]);
        puts("");
    }

}

void print_result_matrix(int result_matrix[2][2])
{
    int i,j;
    for(i=0; i<2; i++) {
        for(j=0; j<2; j++)
            printf("%4d",result_matrix[i][j]);
        puts("");
    }
}


void add_matrices(int (*argument_1)[COLUMNS], int (*argument_2)[COLUMNS], int result[ROWS][COLUMNS])
{
    int i,j;
    for(i=0; i<ROWS; i++)
        for(j=0; j<COLUMNS; j++)
            result[i][j] = argument_1[i][j] + argument_2[i][j];
}

void substract_matrices(int (*argument_1)[COLUMNS], int (*argument_2)[COLUMNS], int result[ROWS][COLUMNS])
{
    int i,j;
    for(i=0; i<ROWS; i++)
        for(j=0; j<COLUMNS; j++)
            result[i][j] = argument_1[i][j] - argument_2[i][j];
}

void fill_rectangular_matrix(int matrix[][COLUMNS])
{
    int i,j;
    srand(time(0));
    for(i=0; i<ROWS; i++)
        for(j=0; j<COLUMNS; j++)
            matrix[i][j] = rand()%10;
}

void multiply_matrices(int argument_1[2][3], int argument_2[3][2], int result[2][2])
{
    int i,j,k;
    for(i=0; i<2; i++)
        for(k=0; k<3; k++)
            for(j=0; j<2; j++)
                result[i][j] += argument_1[i][k]*argument_2[k][j];
}

void transpose_matrix(int argument[ROWS][COLUMNS], int result[COLUMNS][ROWS])
{
    int i,j;
    for(i=0; i<2; i++)
        for(j=0; j<3; j++)
            result[j][i]=argument[i][j];
}

void print_transposed_matrix(int (*matrix)[ROWS])
{
    int i,j;
    for(i=0; i<COLUMNS; i++) {
        for(j=0; j<ROWS; j++)
            printf("%4d",matrix[i][j]);
        puts("");
    }
}


void transpose_square_matrix(int matrix [3][3])
{
    int i,j;
    for(i=0; i<3; i++)
        for(j=0; j<i; j++) {
                int tmp;
                tmp = matrix[i][j];
                matrix[i][j] = matrix[j][i];
                matrix[j][i] = tmp;
        }
}

void print_square_matrix(int matrix[3][3])
{
    int i;
    for(i=0; i<3; i++) {
        int j;
        for(j=0; j<3; j++)
            printf("%4d", matrix[i][j]);
        puts("");
    }
}


int main(void)
{
    multiply_matrices(matrix_1,matrix_2,result_matrix);
    puts("Wynik mnożenia:");
    print_result_matrix(result_matrix);
    transpose_matrix(matrix_1,matrix_3);
    puts("Wynik transponowania:");
    print_transposed_matrix(matrix_3);
    fill_rectangular_matrix(matrix_4);
    puts("Wylosowana macierz:");
    print_rectangular_matrix(matrix_4);
    add_matrices(matrix_1,matrix_4,matrix_5);
    puts("Wynik dodawania:");
    print_rectangular_matrix(matrix_5);
    substract_matrices(matrix_4,matrix_1,matrix_5);
    puts("Wynik odejmowania");
    print_rectangular_matrix(matrix_5);
    puts("Macierz kwadratowa");
    print_square_matrix(square_matrix);
    transpose_square_matrix(square_matrix);
    puts("Macierz kwadratowa");
    print_square_matrix(square_matrix);
    return 0;
}
