#include <stdio.h>
#include <string.h>

#define LENGTH 50
#define NUMBER 6

char cities[][LENGTH] = {"Bruksela","Amsterdam","Antwerpia","Kraków","Wiedeń","Warszawa"};

void print_cities(char cities[][LENGTH])
{
    int i;
    for(i=0; i<NUMBER; i++)
        printf("%s ",cities[i]);
    puts("");
}

void swap(char first[], char second[])
{
    char tmp[LENGTH];

    strncpy(tmp,first,LENGTH-1);
    strncpy(first,second,LENGTH-1);
    strncpy(second,tmp,LENGTH-1);
}


void sort_cities(char (*cities)[LENGTH])
{
    int i,j;

    for(i=0; i<NUMBER-1; i++) {
        int min = i;
        for(j=i+1; j<NUMBER; j++)
            if(strncmp(cities[min],cities[j],LENGTH-1)>0)
                min = j;
        if(min!=i)
            swap(cities[min],cities[i]);
    }
}


int main(void)
{
    print_cities(cities);
    sort_cities(cities);
    print_cities(cities);
    return 0;
}
